#
# spec file for package jitsi
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define release_number 4506.10553
%define release_prefix build.%{release_number}

%define libdir_name jitsi

Name:           jitsi
Version:        2.0
Vendor:	         MLO <http://www.mageialinux-online.org>
Packager:	 Adrien.D & david.david (MLO Team)
Release:	 %mkrel 2
Summary:        Multiprotocol (SIP, XMPP/Jabber, ecc.) VoIP and instant messaging software
Group:          Productivity/Networking/Instant Messenger
License:        LGPL-2.1+
Url:            http://www.jitsi.org
Source0:        http://download.jitsi.org/jitsi/src/jitsi-src-%{version}.%{release_number}.zip
Source1:        jitsi-32.sh
Source2:        jitsi-64.sh
Source3:        Jitsi.desktop
Source4:        jitsi_100x100.png
Source5:        jdic.tar.xz
Source6:        ldns-1.6.11.tar.xz
Source7:        unbound-1.4.14.tar.xz
# PATCH-FIX-OPENSUSE build.xml.root.patch -- fixes the ant script forcing the build for java 1.5
Patch1:         build.xml.root.patch
# PATCH-FIX-UPSTREAM net_java_sip_communicator_impl_sysactivity_SystemActivityNotifications.c.patch -- fixes the use of deprecated functions
Patch2:         sysactivity.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  java >= 1.6.0 java-devel >= 1.6.0 xalan-j2 ant ant-nodeps
BuildRequires:  gcc-c++ xz unzip dbus-devel
BuildRequires:  portaudio-devel speex speex-devel
BuildRequires:  x11-proto-devel x11-xtrans-devel
BuildRequires:  glib2-devel gtk2-devel gnome-vfs2-devel
%ifarch x86_64 amd64
BuildRequires:  lib64gnome2-devel
%else
BuildRequires:  libgnome2-devel
%endif


Requires:	 java-1.7.0-openjdk


%description
Jitsi is an audio/video and chat communicator that supports protocols
such as SIP, XMPP/Jabber, AIM/ICQ, Windows Live, Yahoo!, Bonjour and many other
useful features such as voice and chat encryption.

%prep
%setup -T -q -n jitsi -b 0
tar -xf %{SOURCE5}
%patch1
%patch2

%build

export CFLAGS="%{optflags} $CFLAGS"
export CXXFLAGS="%{optflags} $CXXFLAGS"
export CPPFLAGS="%{optflags} $CPPFLAGS"

#Build main program
%ant rebuild

#Build hid
%ant hid

#Build galagonotification
#Hidden dbus header
export CPATH="%{_libdir}/dbus-1.0/include"
%ant galagonotification

#Build hwaddressretriever
%ant hwaddressretriever

#Build g722
%ant g722

#Build screencapture
%ant screencapture

#Build portaudio !!! BUILD DISABLED DUE TO UNOFFICIAL VERSION USED
#Link hidden shared libraries
#mkdir -p %{_builddir}/build_libraries
#export CPATH="%{_builddir}/build_libraries:$CPATH"
#%if 0%{?suse_version}
# mkdir -p %{_builddir}/link_libraries
# export LIBRARY_PATH="%{_builddir}/link_libraries:$LIBRARY_PATH"
# ln --symbolic %{_libdir}/libasound.so.2 %{_builddir}/link_libraries/libasound.so
#%endif
#if [ ! -e %{_prefix}/include/glib-2.0/glibconfig.h ]
#then
# ln --symbolic %{_libdir}/glib-2.0/include/glibconfig.h %{_builddir}/build_libraries/glibconfig.h
#fi
#if [ ! -e %{_prefix}/include/gtk-2.0/gdkconfig.h ]
#then
# ln --symbolic %{_libdir}/gtk-2.0/include/gdkconfig.h %{_builddir}/build_libraries/gdkconfig.h
#fi
#\%ant portaudio -Dportaudio=a -Dspeex=a

#Build speex
%ant speex -Dspeex.dynamic=true

#Build sysactivity
%ant sysactivity

#Build jdic
cd jdic/jdic
%ant buildunixjni
%ifarch x86_64 amd64
  cp dist/linux/libjdic.so ../../lib/native/linux-64
  cp dist/linux/libtray.so ../../lib/native/linux-64
%else
  cp dist/linux/libjdic.so ../../lib/native/linux
  cp dist/linux/libtray.so ../../lib/native/linux
%endif
cd ../..

#Build globalshortcut
%ant globalshortcut

#Build libjunbound
%if 0%{?suse_version}
export CPATH="%{_libdir}/jvm/java/include/linux:$CPATH"
cd src/native/libjunbound
out=`pwd`/build/linux
prefix=$out/libs
mkdir -p $out
mkdir -p $prefix
cd $out
ldns=ldns-1.6.11
unbound=unbound-1.4.14
cp %{SOURCE6} .
cp %{SOURCE7} .
tar -xJvf $ldns.tar.xz
tar -xJvf $unbound.tar.xz
cd $out/$ldns
./configure --with-pic --prefix=$prefix CFLAGS="%{optflags}"
make %{?_smp_mflags}
make install
cd $out/$unbound
patch -p 1 -i $out/../../unbound.patch
./configure --with-pic --prefix=$prefix --with-ldns=$prefix CFLAGS="%{optflags}"
make %{?_smp_mflags}
make install
cd $out
gcc %{optflags} $out/../../src/net_java_sip_communicator_impl_dns_UnboundApi.cpp -fpic -shared -o libjunbound.so -I%{_libdir}/jvm/java/include -I%{_libdir}/jvm/java/include/linux -Wl,-Bstatic -L$prefix/lib -lunbound -lldns -I$prefix/include -Wl,-Bdynamic -lcrypto
strip libjunbound.so
%ifarch x86_64 amd64
  cp ./libjunbound.so ../../../../../lib/native/linux-64
%else
  cp ./libjunbound.so ../../../../../lib/native/linux
%endif
cd ../../..
%endif


%install

#Install bundles
mkdir -p %{buildroot}%{_libdir}/%{libdir_name}
rm -f sc-bundles/*-slick.jar
mkdir -p %{buildroot}%{_libdir}/%{libdir_name}/sc-bundles
cp -r sc-bundles/os-specific/linux/* %{buildroot}%{_libdir}/%{libdir_name}/sc-bundles/
rm -f -r sc-bundles/os-specific
cp -r sc-bundles/* %{buildroot}%{_libdir}/%{libdir_name}/sc-bundles/

#Install other bundles and libs
mkdir -p %{buildroot}%{_libdir}/%{libdir_name}/lib
rm -r -f lib/os-specific/linux/*exclude
rm -r -f lib/os-specific/linux/.svn
cp -r lib/os-specific/linux/* %{buildroot}%{_libdir}/%{libdir_name}/lib/
rm -r -f lib/os-specific
rm -r -f lib/bundle/.svn
cp -r lib/bundle %{buildroot}%{_libdir}/%{libdir_name}/lib/
rm -r -f lib/bundle

#Install native libraries
mkdir -p %{buildroot}%{_libdir}/%{libdir_name}/lib/native
%ifarch x86_64 amd64
    rm -r -f lib/native/linux-64/*exclude
    rm -r -f lib/native/linux-64/.svn
    cp lib/native/linux-64/* %{buildroot}%{_libdir}/%{libdir_name}/lib/native/
%else
    rm -r -f lib/native/linux/*exclude
    rm -r -f lib/native/linux/.svn
    rm -r -f lib/native/linux/*mozembed*
    cp lib/native/linux/* %{buildroot}%{_libdir}/%{libdir_name}/lib/native/
%endif
rm -r -f lib/native
rm -r -f lib/*exclude
rm -r -f lib/.svn
cp -r lib/* %{buildroot}%{_libdir}/%{libdir_name}/lib/
rm -f %{buildroot}%{_libdir}/%{libdir_name}/lib/native/libunix-java.so
ln --symbolic %{_libdir}/libunix-java.so %{buildroot}%{_libdir}/%{libdir_name}/lib/native/libunix-java.so

#Install jdic
cp jdic/jdic/dist/linux/libjdic.so %{buildroot}%{_libdir}/%{libdir_name}/lib/native/
cp jdic/jdic/dist/linux/libtray.so %{buildroot}%{_libdir}/%{libdir_name}/lib/native/

#Install executable start script
mkdir -p %{buildroot}%{_bindir}
%ifarch x86_64 amd64
    cp -r %{SOURCE2} %{buildroot}%{_bindir}/jitsi
%else
    cp -r %{SOURCE1} %{buildroot}%{_bindir}/jitsi
%endif

#Install icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
cp resources/images/logo/sc_logo_45x45.png %{buildroot}%{_datadir}/pixmaps/
cp %{SOURCE4} %{buildroot}%{_datadir}/pixmaps/

#Install desktop file
mkdir -p %{buildroot}%{_datadir}/applications/
cp %{SOURCE3} %{buildroot}%{_datadir}/applications/
%if 0%{?suse_version}
  %suse_update_desktop_file Jitsi Network Telephony InstantMessaging
%else
  desktop-file-install --add-category="Network;Telephony" --dir=%{buildroot}%{_datadir}/applications %{SOURCE3}
%endif


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{_libdir}/%{libdir_name}
%{_datadir}/pixmaps/sc_logo_45x45.png
%{_datadir}/pixmaps/jitsi_100x100.png
%{_datadir}/applications/Jitsi.desktop
%attr(0755,root,root) %{_bindir}/jitsi


%changelog

* Tue Apr 04 2013  AdrienD <adriend> 2.0-2.mga2
+ Rebuild SPEC File with OpenSuse source.
    
* Tue Apr 04 2013 david.david (MLO Team) <david.david> 2.0-1.mga2
+ New version 2.0
- clean "spec" file
    
    - Fixed startup script. 
    - Add felix.framework and felix.main dependencies.
    - Fix warning about conflicting folders with filesystem package.
    
* Sun Feb 24 2013 AdrienD <adriend> 1.0-1-mga2
- New RPM